diff -arcN emacs-18.55/man/texindex.c nemacs-3.3.2/man/texindex.c
*** emacs-18.55/man/texindex.c	Tue Jul 12 07:04:07 1988
--- nemacs-3.3.2/man/texindex.c	Wed Jun  6 03:17:47 1990
***************
*** 1,3 ****
--- 1,6 ----
+ /* 89.11.23 modified for Nemacs Ver.3.2 by K.Handa
+    to handle Japanese code (EUC).  */
+ 
  /* Prepare Tex index dribble output into an actual index.
     Copyright (C) 1987 Free Software Foundation, Inc.
  
***************
*** 123,128 ****
--- 126,135 ----
  #define L_XTND 2
  #endif
  
+ /* patch by K.Handa  89.11.23 */
+ #define EUC_P(c) ((unsigned char)c >= 0xa1 && (unsigned char)c <= 0xfe)
+ /* end of patch */
+ 
  /* When sorting in core, this structure describes one line
   and the position and length of its first keyfield.  */
  
***************
*** 726,731 ****
--- 733,743 ----
      char_order[i] = 512 + i;
      char_order[i + 'A' - 'a'] = 512 + i;
    }
+ /* patch by K.Handa  89.11.23 */
+   for (i = 0xa1; i <= 0xfe; i++)
+     char_order[i] = 512 + i;
+   char_order[0xa4] = char_order[0xa5];
+ /* end of patch */
  }
  
  /* Compare two fields (each specified as a start pointer and a character count)
***************
*** 757,766 ****
      }
    else
      {
!       char *p1 = start1;
!       char *p2 = start2;
!       char *e1 = start1 + length1;
!       char *e2 = start2 + length2;
  
        int fold_case = keyfield->fold_case;
  
--- 769,781 ----
      }
    else
      {
! /* patch by K.Handa  89.11.23 */
! /* original types are 'char' */
!       unsigned char *p1 = (unsigned char *)start1;
!       unsigned char *p2 = (unsigned char *)start2;
!       unsigned char *e1 = (unsigned char *)start1 + length1;
!       unsigned char *e2 = (unsigned char *)start2 + length2;
! /* end of patch */
  
        int fold_case = keyfield->fold_case;
  
***************
*** 775,786 ****
  
  	  if (char_order[c1] != char_order[c2])
  	    return char_order[c1] - char_order[c2];
  	  if (!c1) break;
  	}
  
        /* Strings are equal except possibly for case.  */
!       p1 = start1;
!       p2 = start2;
        while (1)
  	{
  	  int c1, c2;
--- 790,816 ----
  
  	  if (char_order[c1] != char_order[c2])
  	    return char_order[c1] - char_order[c2];
+ /* patch by K.Handa  89.11.23 */
+ 	  if (EUC_P(c1) && c2) {
+ 	    c1 = *p1++;
+ 	    c2 = *p2++;
+ 	    if (*(p1-2) == 0xa3) {
+ 	      if (0xe1 <= c1 && c1 <= 0xfa) c1 -= 0x20;
+ 	      if (0xe1 <= c2 && c2 <= 0xfa) c2 -= 0x20;
+ 	      if (c1 != c2) return c2 - c1;
+ 	    } else if (c1 != c2)
+ 	      return c1 - c2;
+ 	  }
+ /* end of patch */
  	  if (!c1) break;
  	}
  
        /* Strings are equal except possibly for case.  */
!       /* ... and for Hiragana-Katakana. */ /* patch by K.Handa  89.11.23 */
! /* type casting patch by K.Handa  89.11.23 */
!       p1 = (unsigned char *)start1;
!       p2 = (unsigned char *)start2;
! /* end of patch */
        while (1)
  	{
  	  int c1, c2;
***************
*** 793,798 ****
--- 823,836 ----
  	  if (c1 != c2)
  	    /* Reverse sign here so upper case comes out last.  */
  	    return c2 - c1;
+ /* patch by K.Handa  89.11.23 */
+ 	  if (EUC_P(c1) && c2) {
+ 	    c1 = *p1++;
+ 	    c2 = *p2++;
+ 	    if (*(p1-2) == 0xa3) return c2 - c1;
+ 	    else return c1 - c2;
+ 	  }
+ /* end of patch */
  	  if (!c1) break;
  	}
  
***************
*** 1143,1149 ****
--- 1181,1192 ----
  /* When we need a string of length 1 for the value of lastinitial,
     store it here.  */
  
+ /* patch by K.Handa  89.11.23 */
+ /* original line is
  char lastinitial1[2];
+    and new line is */
+ char lastinitial1[3];
+ /* end of patch */
  
  /* Initialize static storage for writing an index */
  
***************
*** 1154,1159 ****
--- 1197,1203 ----
    lastinitial = lastinitial1;
    lastinitial1[0] = 0;
    lastinitial1[1] = 0;
+   lastinitial1[2] = 0;		/* patch by K.Handa  89.11.23 */
    lastinitiallength = 0;
    lastprimarylength = 100;
    lastprimary = (char *) xmalloc (lastprimarylength + 1);
***************
*** 1176,1182 ****
--- 1220,1231 ----
    int nosecondary;
    int initiallength;
    char *initial;
+ /* patch by K.Handa  89.11.23 */
+ /* original line is
    char initial1[2];
+    and new line is */
+   char initial1[3];
+ /* end of patch */
    register char *p;
  
    /* First, analyze the parts of the entry fed to us this time */
***************
*** 1193,1203 ****
--- 1242,1265 ----
      {
        initial = initial1;
        initial1[0] = *p;
+ /* patch by K.Handa  89.11.23 */
+       if (EUC_P (*p)) {
+ 	initial1[1] = *(p+1);
+ 	initial1[2] = 0;
+ 	initiallength = 2;
+ 	if ((unsigned char)*p == 0xa4) initial1[0] = (char)0xa5;
+ 	else if ((unsigned char)*p == 0xa3
+ 		 && (unsigned char)initial1[1] >= 0xe1
+ 		 && (unsigned char)initial1[1] <= 0xfa)
+ 	  initial1[1] -= 0x20;
+       } else {
+ /* end of patch */
        initial1[1] = 0;
        initiallength = 1;
  
        if (initial1[0] >= 'a' && initial1[0] <= 'z')
  	initial1[0] -= 040;
+       }				/* patch by K.Handa  89.11.23 */
      }
  
    pagenumber = find_braced_pos (line, 1, 0, 0);
***************
*** 1234,1239 ****
--- 1296,1302 ----
  	    {
  	      lastinitial = lastinitial1;
  	      *lastinitial1 = *initial1;
+ 	      lastinitial1[1] = initial1[1]; /* patch by K.Handa  89.11.23 */
  	    }
  	  else
  	    {
diff -arcN emacs-18.55/src/Makefile nemacs-3.3.2/src/Makefile
*** emacs-18.55/src/Makefile	Tue Aug  8 10:12:47 1989
--- nemacs-3.3.2/src/Makefile	Wed Jun  6 03:19:11 1990
***************
*** 1,3 ****
--- 1,6 ----
+ # 90.2.27  modified for Nemacs Ver.3.3 by K.Handa
+ #	add dependency on nconfig.h to xmakefile
+ 
  CPP = cc -E
  MAKE = make  # BSD doesn't have it as a default.
  #Note: an alternative is  CPP = /lib/cpp
***************
*** 28,34 ****
  
  # If you have a problem with cc -E here, changing
  # the definition of CPP above may fix it.
! xmakefile: ymakefile config.h
  	rm -f xmakefile
  	cp ymakefile junk.c
  	$(CPP) junk.c | sed -e 's/^#.*//' -e 's/^[ \f\t][ \f\t]*$$//' -e 's/^ /	/' | \
--- 31,37 ----
  
  # If you have a problem with cc -E here, changing
  # the definition of CPP above may fix it.
! xmakefile: ymakefile config.h nconfig.h
  	rm -f xmakefile
  	cp ymakefile junk.c
  	$(CPP) junk.c | sed -e 's/^#.*//' -e 's/^[ \f\t][ \f\t]*$$//' -e 's/^ /	/' | \
diff -arcN emacs-18.55/src/alloc.c nemacs-3.3.2/src/alloc.c
*** emacs-18.55/src/alloc.c	Mon Feb 13 19:23:35 1989
--- nemacs-3.3.2/src/alloc.c	Wed Jun  6 03:18:07 1990
***************
*** 393,398 ****
--- 393,400 ----
    p->bufpos = 0;
    p->modified = 0;
    p->chain = Qnil;
+ /* patch for point_type_marker by K.Handa 89.11.30 */
+   p->type = MARKER_OLD_TYPE;
    consing_since_gc += sizeof (struct Lisp_Marker);
    return val;
  }
diff -arcN emacs-18.55/src/buffer.c nemacs-3.3.2/src/buffer.c
*** emacs-18.55/src/buffer.c	Fri Jul 21 07:36:02 1989
--- nemacs-3.3.2/src/buffer.c	Wed Jun  6 03:18:07 1990
***************
*** 1,3 ****
--- 1,10 ----
+ /* 87.12.9  modified for Nemacs Ver.2.0 by K.Handa */
+ /* 88.2.1   modified by K.Handa */
+ /* 89.3.10  modified for Nemacs Ver.3.0 by K.Handa */
+ /* 89.11.24 modified for attribute of characters by K.Handa */
+ /* 90.1.12  modified for Nemacs Ver.3.3.1 by K.Handa
+ 		'validate_region' is changed. */
+ 
  /* Buffer manipulation primitives for GNU Emacs.
     Copyright (C) 1985, 1986, 1987, 1988 Free Software Foundation, Inc.
  
***************
*** 35,40 ****
--- 42,50 ----
  #include "commands.h"
  #include "buffer.h"
  #include "syntax.h"
+ #ifdef NEMACS  /* 87.12.9  by K. Handa */
+ #include "kanji.h"
+ #endif
  
  struct buffer *bf_cur;		/* the current buffer */
  
***************
*** 98,103 ****
--- 108,117 ----
  /* For debugging; temporary.  See SetBfp.  */
  /* Lisp_Object Qlisp_mode, Vcheck_symbol; */
  
+ #ifdef NEMACS  /* 89.3.20  by K.Handa, S.Tomura */
+ Lisp_Object Qkanji_fileio_code;
+ #endif
+ 
  nsberror (spec)
       Lisp_Object spec;
  {
***************
*** 239,244 ****
--- 253,262 ----
    b->auto_save_modified = 0;
    b->auto_save_file_name = Qnil;
    b->read_only = Qnil;
+ /* patch for attribute of characters by K.Handa 89.11.21 */
+   b->underlined_region = Qnil;
+   b->inversed_region = Qnil;
+ /* end of patch */
    reset_buffer_local_variables(b);
  }
  
***************
*** 953,958 ****
--- 971,980 ----
        XFASTINT (*e) = i;	/* because this is all we do with i.  */
      }
  
+ #ifdef NEMACS  /* 89.3.10, 90.1.12  by K.Handa */
+   if (kanji_point(XFASTINT(*b)) == 2) XFASTINT(*b)--;
+   if (kanji_point(XFASTINT(*e)) == 2) XFASTINT(*e)++;
+ #endif
    if (!(FirstCharacter <= XINT (*b) && XINT (*b) <= XINT (*e)
          && XINT (*e) <= 1 + NumCharacters))
      args_out_of_range (*b, *e);
***************
*** 1100,1106 ****
    XFASTINT (buffer_defaults.tab_width) = 8;
    buffer_defaults.truncate_lines = Qnil;
    buffer_defaults.ctl_arrow = Qt;
! 
    XFASTINT (buffer_defaults.fill_column) = 70;
    XFASTINT (buffer_defaults.left_margin) = 0;
  
--- 1122,1131 ----
    XFASTINT (buffer_defaults.tab_width) = 8;
    buffer_defaults.truncate_lines = Qnil;
    buffer_defaults.ctl_arrow = Qt;
! #ifdef NEMACS  /* 87.12.9, 89.2.26  by K.Handa */
!   buffer_defaults.kanji_flag = Qt;
!   buffer_defaults.kanji_fileio_code = Qnil;
! #endif
    XFASTINT (buffer_defaults.fill_column) = 70;
    XFASTINT (buffer_defaults.left_margin) = 0;
  
***************
*** 1122,1127 ****
--- 1147,1157 ----
    XFASTINT (buffer_local_flags.read_only) = -1;
    XFASTINT (buffer_local_flags.major_mode) = -1;
    XFASTINT (buffer_local_flags.mode_name) = -1;
+ /* patch for attribute of characters by K.Handa 89.11.21 */
+   XFASTINT (buffer_local_flags.underlined_region) = -1;
+   XFASTINT (buffer_local_flags.inversed_region) = -1;
+ /* end of patch */
+ 
    
    XFASTINT (buffer_local_flags.mode_line_format) = 1;
    XFASTINT (buffer_local_flags.abbrev_mode) = 2;
***************
*** 1136,1141 ****
--- 1166,1175 ----
    XFASTINT (buffer_local_flags.fill_column) = 0x400;
    XFASTINT (buffer_local_flags.left_margin) = 0x800;
    XFASTINT (buffer_local_flags.abbrev_table) = 0x1000;
+ #ifdef NEMACS  /* 88.2.25, 89.12.15  by K.Handa */
+   XFASTINT (buffer_local_flags.kanji_flag) = 0x2000;
+   XFASTINT (buffer_local_flags.kanji_fileio_code) = 0x4000;
+ #endif
  
    Vbuffer_alist = Qnil;
    bf_cur = 0;
***************
*** 1234,1239 ****
--- 1268,1285 ----
      "Default case-fold-search for buffers that do not override it.\n\
  This is the same as (default-value 'case-fold-search).");
  
+ #ifdef NEMACS  /* 87.12.9  by K.Handa */
+   DEFVAR_LISP_NOPRO ("default-kanji-flag",
+ 	      &buffer_defaults.kanji_flag,
+     "Default kanji-flag for buffers that do not override it.\n\
+ This is the same as (default-value 'kanji-flag).");
+ 
+   DEFVAR_LISP_NOPRO ("default-kanji-fileio-code",
+               &buffer_defaults.kanji_fileio_code,
+     "Default kanji-fileio-code for buffers that do not override it.\n\
+ This is the same as (default-value 'kanji-fileio-code).");
+ #endif
+ 
    DEFVAR_PER_BUFFER ("mode-line-format", &bf_cur->mode_line_format, 0);
  
  /* This doc string is too long for cpp; cpp dies.
***************
*** 1260,1265 ****
--- 1306,1312 ----
    %s -- print process status.   %M -- print value of global-mode-string. (obs)\n\
    %p -- print percent of buffer above top of window, or top, bot or all.\n\
    %n -- print Narrow if appropriate.\n\
+   %c -- print kanji code for fileio, input, and display.\n\
    %[ -- print one [ for each recursive editing level.  %] similar.\n\
    %% -- print %.   %- -- print infinitely many dashes.\n\
  Decimal digits after the % specify field width to which to pad.");
***************
*** 1309,1314 ****
--- 1356,1386 ----
  Note that this is overridden by the variable\n\
  truncate-partial-width-windows if that variable is non-nil\n\
  and this buffer is not full-screen width.");
+ 
+ #ifdef NEMACS  /* 87.12.9, 89.3.10  by K.Handa */
+   DEFVAR_PER_BUFFER ("kanji-flag", &bf_cur->kanji_flag,
+     "*non-nil means that this buffer recognizes kanji-code.");
+ 
+   DEFVAR_PER_BUFFER ("kanji-fileio-code", &bf_cur->kanji_fileio_code,
+     "*kanji-code for file and process input/output .\n\
+ 0:EUC/AT&T/DEC  1:Shift-JIS  2:JIS");
+ 
+   Qkanji_fileio_code = intern("kanji-fileio-code");
+ #endif
+ 
+ /* patch for attribute of characters by K.Handa 89.11.21 */
+   DEFVAR_PER_BUFFER ("underlined-region", &bf_cur->underlined_region,
+     "*Underlined region of current buffer.  Should be a list of\n\
+ LENGTH and several numbers of MARKER_i, where MARKER_i indicates\n\
+ underline starting point if 'i' is even and underline ending point\n\
+ if 'i' is odd.  LENGTH is a length of this list.");
+ 
+   DEFVAR_PER_BUFFER ("inversed-region", &bf_cur->inversed_region,
+     "*Inversed region of current buffer.  Should be a list of\n\
+ LENGTH and several numbers of MARKER_i, where MARKER_i indicates\n\
+ inverse starting point if 'i' is even and inverse ending point\n\
+ if 'i' is odd.  LENGTH is a length of this list.");
+ /* end of patch */
  
    DEFVAR_PER_BUFFER ("default-directory", &bf_cur->directory,
      "Name of default directory of current buffer.  Should end with slash.");
diff -arcN emacs-18.55/src/buffer.h nemacs-3.3.2/src/buffer.h
*** emacs-18.55/src/buffer.h	Sun Feb  8 23:35:54 1987
--- nemacs-3.3.2/src/buffer.h	Wed Jun  6 03:18:16 1990
***************
*** 1,3 ****
--- 1,8 ----
+ /* 87.5.1   modified by K.Handa */
+ /* 87.12.9  modified for Nemacs Ver.2.0 by K.Handa */
+ /* 89.3.10  modified for Nemacs Ver.3.0 by K.Handa */
+ /* 89.11.21 modified for attribute of characters by K.Handa */
+ 
  /* Header file for the buffer manipulation primitives.
     Copyright (C) 1985, 1986 Free Software Foundation, Inc.
  
***************
*** 24,33 ****
--- 29,45 ----
  #endif /* lint */
  
  
+ #ifdef NEMACS  /* 87.5.1  by K.Handa */
+ #define SetPoint(n)  point = set_point(n)
+ 
+ #define PointRight(n)  point = set_point(point + n)
+ #define PointLeft(n)  point = set_point(point - n)
+ #else  /* not NEMACS */
  #define SetPoint  point =
  
  #define PointRight  point +=
  #define  PointLeft  point -=
+ #endif  /* not NEMACS */
  
  struct buffer_text
    {
***************
*** 153,158 ****
--- 165,178 ----
      Lisp_Object overwrite_mode;
      /* non-nil means abbrev mode is on.  Expand abbrevs automatically. */
      Lisp_Object abbrev_mode;
+ #ifdef NEMACS  /* 87.12.9, 89.3.10  by K.Handa */
+     Lisp_Object kanji_flag;
+     Lisp_Object kanji_fileio_code;
+ #endif
+ /* patch for attribute of characters by K.Handa 89.11.21 */
+     Lisp_Object underlined_region;
+     Lisp_Object inversed_region;
+ /* end of patch */
  };
  
  extern struct buffer *bf_cur;		/* points to the current buffer */
***************
*** 191,196 ****
--- 211,220 ----
     that don't have such names.  */
  
  extern struct buffer buffer_local_symbols;
+ 
+ #ifdef NEMACS  /* 89.3.20  by K.Handa */
+ extern Lisp_Object Qkanji_fileio_code;
+ #endif
  
  /* Some aliases for info about the current buffer.  */
  
diff -arcN emacs-18.55/src/bytecode.c nemacs-3.3.2/src/bytecode.c
*** emacs-18.55/src/bytecode.c	Wed Mar 18 04:15:16 1987
--- nemacs-3.3.2/src/bytecode.c	Wed Jun  6 03:18:16 1990
***************
*** 1,3 ****
--- 1,5 ----
+ /* 90.3.27  modified by toshiki@sm.sony.co.jp */
+ 
  /* Execution of byte code produced by bytecomp.el.
     Copyright (C) 1985, 1986, 1987 Free Software Foundation, Inc.
  
***************
*** 269,274 ****
--- 271,279 ----
  	     cause disasters.  */
  	  gcpro3.nvars = &TOP - stack - 1;
  	  TOP = Ffuncall (op + 1, &TOP);
+ /* patched by toshiki 90/3/27 */
+ 	  bzero (&TOP+1, (stacke - &TOP) * sizeof (Lisp_Object));
+ /* end of patch */
  	  gcpro3.nvars = XFASTINT (maxdepth);
  	  break;
  
diff -arcN emacs-18.55/src/callproc.c nemacs-3.3.2/src/callproc.c
*** emacs-18.55/src/callproc.c	Thu Jul 20 14:15:50 1989
--- nemacs-3.3.2/src/callproc.c	Wed Jun  6 03:18:15 1990
***************
*** 1,3 ****
--- 1,13 ----
+ /* modified by A.Kato(kato@koudai.cs.titech.junet)  87.7.7 */
+ /* 87.7.7   modified by K.Handa */
+ /* 87.12.10 modified for Nemacs Ver.2.0 by K.Handa */
+ /* 88.1.25  modified by K.Handa according to a patch by Mr.Sanewo (88.3.6) */
+ /* 88.5.25  modified for Nemacs Ver.2.1 by K.Handa */
+ /* 88.3.23  modified for Nemacs Ver.3.0 by K.Handa, S.Tomura */
+ /* 89.9.12  modified for Nemacs Ver.3.2 by S.Tomura */
+ /* 90.2.28  modified for Nemacs Ver.3.3.1 by K.Handa
+ 	do GCPRO (proc) before Ffuncall */
+ 
  /* Synchronous subprocess invocation for GNU Emacs.
     Copyright (C) 1985, 1986, 1987, 1988 Free Software Foundation, Inc.
  
***************
*** 42,47 ****
--- 52,63 ----
  #include "commands.h"
  #include "buffer.h"
  #include "paths.h"
+ #ifdef NEMACS  /* 89.2.23, 89.3.20  by K.Handa */
+ #include "kanji.h"
+ #include "process.h"
+ 
+ Lisp_Object just_decided_kanji_process_code;
+ #endif
  
  #define max(a, b) ((a) > (b) ? (a) : (b))
  
***************
*** 238,244 ****
--- 254,295 ----
    {
      register int nread;
  
+ #ifdef NEMACS  /* 87.7.7  by A.Kato, 87.12.10, 88.5.25, 89.2.22 by K.Handa */
+     int kanji = 0, i;
+     unsigned char *name = XSTRING (args[0])->data;
+     Lisp_Object code = just_decided_kanji_process_code;
+     /* 89.9.12 by S. Tomura */
+     if (NULL (code) &&
+ 	EQ (Fboundp (Qfind_kanji_process_code), Qt) ) {
+       Lisp_Object *newargs
+ 	  = (Lisp_Object *) alloca ((sizeof (Lisp_Object *))
+ 				   * ((nargs > 4) ? nargs : 4));
+       if (!newargs) memory_full();
+       newargs[0] = Qinvoke_find_kanji_process_code;
+       newargs[1] = (!XFASTINT(buffer) || NULL(buffer))
+ 	? Qnil
+ 	  : (EQ (buffer, Qt) ? Qt : Fbuffer_name(buffer));
+       newargs[2] = args[0];
+       newargs[3] = Qnil;
+       if (nargs > 4) {
+ 	for (i = 4; i < nargs; i++) newargs[i] = args[i];
+       } else
+ 	nargs = 4;
+       code = Ffuncall (nargs, newargs);
+     } else
+       just_decided_kanji_process_code = Qnil;
+     if (XTYPE(code) != Lisp_Int) code = make_number (NOCONV);
+ 
+   retry:
+     while ((nread =
+ 	    (NULL(code) || XFASTINT(code) == EUC || XFASTINT(code) == NOCONV)
+ 	    ? (nread = read(fd[0], buf, sizeof buf)) ? nread : -1
+ 	    : kanji_read_from_process(fd[0], buf, 0,
+ 				      sizeof buf, &kanji,
+ 				      XFASTINT(code))) > 0)
+ #else  /* not NEMACS */
      while ((nread = read (fd[0], buf, sizeof buf)) > 0)
+ #endif
        {
  	immediate_quit = 0;
  	if (!NULL (buffer))
***************
*** 248,255 ****
  	immediate_quit = 1;
  	QUIT;
        }
-   }
  
    /* Wait for it to terminate, unless it already has.  */
    wait_for_termination (pid);
  
--- 299,309 ----
  	immediate_quit = 1;
  	QUIT;
        }
  
+ #ifdef NEMACS  /* 88.5.25, 89.3.21  by K.Handa */
+     if (!NULL(code) && XFASTINT(code) != EUC && nread == 0) goto retry;
+ #endif
+   }
    /* Wait for it to terminate, unless it already has.  */
    wait_for_termination (pid);
  
***************
*** 275,281 ****
--- 329,339 ----
       int nargs;
       register Lisp_Object *args;
  {
+ #ifdef NEMACS  /* 90.3.1  by K.Handa */
+   Lisp_Object filename_string, start, end;
+ #else
    register Lisp_Object filename_string, start, end;
+ #endif
    char tempfile[20];
  
    strcpy (tempfile, "/tmp/emacsXXXXXX");
***************
*** 284,290 ****
--- 342,382 ----
    filename_string = build_string (tempfile);
    start = args[0];
    end = args[1];
+ #ifdef NEMACS  /* 89.3.8  by K.Handa 89.9.12 by S.Tomura*/
+   {
+     int count = specpdl_ptr - specpdl;
+     unsigned char *name = XSTRING (args[2])->data;
+     Lisp_Object code = Qnil;
+     if ( EQ ( Fboundp (Qfind_kanji_process_code), Qt ) )
+       {
+ 	int nnewargs = (nargs > 6) ? nargs - 2 : 4;
+ 	Lisp_Object *newargs
+ 	  = (Lisp_Object *) alloca ((sizeof (Lisp_Object *)) * nnewargs);
+ 	struct gcpro gcpro1, gcpro2, gcpro3; /* 90.2.28  by K.Handa */
+ 	if (!newargs) memory_full();
+ 	newargs[0] = Qinvoke_find_kanji_process_code;
+ 	newargs[1] = (NULL(args[4]) || !XFASTINT(args[4]))
+ 	  ? Qnil
+ 	    : ((EQ (args[4], Qt)) ? Qt : Fbuffer_name (args[4]));
+ 	newargs[2] = args[2];
+ 	newargs[3] = Qnil;
+ 	if (nargs > 6) {
+ 	  int i;
+ 	  for (i = 6; i < nargs; i++) newargs[i-2] = args[i];
+ 	}
+ 	GCPRO3 (start, end, filename_string); /* 90.2.28  by K.Handa */
+ 	code = Ffuncall (nnewargs, newargs);
+ 	UNGCPRO;		/* 90.2.28  by K.Handa */
+       }
+     if (XTYPE(code) != Lisp_Int) code = make_number (NOCONV);
+     specbind(Qkanji_fileio_code, code);
+ #endif
    Fwrite_region (start, end, filename_string, Qnil, Qlambda);
+ #ifdef NEMACS  /* 89.3.8  by K.Handa */
+     unbind_to (count);
+     just_decided_kanji_process_code = code;
+   }
+ #endif
  
    if (!NULL (args[3]))
      Fdelete_region (start, end);
***************
*** 437,442 ****
--- 529,537 ----
        Vprocess_environment = Fcons (build_string (*envp),
  				    Vprocess_environment);
  #endif /* MAINTAIN_ENVIRONMENT */
+ #ifdef NEMACS  /* 89.3.21  by K.Handa */
+   just_decided_kanji_process_code = Qnil;
+ #endif
  }
  
  syms_of_callproc ()
diff -arcN emacs-18.55/src/cmds.c nemacs-3.3.2/src/cmds.c
*** emacs-18.55/src/cmds.c	Thu Dec 29 13:09:21 1988
--- nemacs-3.3.2/src/cmds.c	Wed Jun  6 03:18:15 1990
***************
*** 1,3 ****
--- 1,8 ----
+ /* 87.6.10  modified by K.Handa */
+ /* 88.1.5   modified for Nemacs Ver.2.0 by K.Handa */
+ /* 90.3.2   modified for Nemacs Ver.3.3.1 by K.Handa
+ 	overwrite mode for Japanese */
+ 
  /* Simple built-in editing commands.
     Copyright (C) 1985 Free Software Foundation, Inc.
  
***************
*** 24,29 ****
--- 29,37 ----
  #include "commands.h"
  #include "buffer.h"
  #include "syntax.h"
+ #ifdef NEMACS  /* 90.3.2  by K.Handa */
+ #include "kanji.h"
+ #endif
  
  Lisp_Object Qkill_forward_chars, Qkill_backward_chars, Vblink_paren_hook;
  
***************
*** 34,39 ****
--- 42,50 ----
    (n)
       Lisp_Object n;
  {
+ #ifdef NEMACS  /* 89.3.10  by K.Handa */
+   int saved_point = point;
+ #endif
    if (NULL (n))
      XFASTINT (n) = 1;
    else
***************
*** 40,45 ****
--- 51,59 ----
      CHECK_NUMBER (n, 0);
  
    SetPoint (point + XINT (n));
+ #ifdef NEMACS  /* 89.3.10  by K.Handa */
+   if (point == saved_point &&  n > 0) point += 2;
+ #endif  /* NEMACS */
    if (point < FirstCharacter)
      {
        SetPoint (FirstCharacter);
***************
*** 254,260 ****
--- 268,279 ----
    int hairy = 0;
    Lisp_Object tem;
    register enum syntaxcode synt;
+ #ifdef NEMACS  /* 87.6.10  by K.Handa */
+   register int c = (unsigned char)c1;
+   unsigned char c2 = CharAt (point); /* 90.3.2  by K.Handa */
+ #else
    register int c = c1;
+ #endif
  
    if (!NULL (bf_cur->overwrite_mode)
        && point <= NumCharacters
***************
*** 263,268 ****
--- 282,295 ----
  	  || XINT (bf_cur->tab_width) <= 0
  	  || !((current_column () + 1) % XFASTINT (bf_cur->tab_width))))
      {
+ #ifdef NEMACS  /* 90.3.2  by K.Handa */
+       if (EUC_P(c2)) {
+ 	del_range (point, point + 2);
+ 	c2 = ' ';
+ 	InsCStr (&c2, 1);
+ 	PointLeft (1);
+       } else
+ #endif  /* NEMACS */
        del_range (point, point + 1);
        hairy = 1;
      }
***************
*** 275,281 ****
--- 302,312 ----
        if (!NULL (tem))
  	hairy = 1;
      }
+ #ifdef NEMACS  /* 88.1.15  by K.Handa */
+   if ((c == ' ' || c == '\n' || c >= 0200)
+ #else
    if ((c == ' ' || c == '\n')
+ #endif
        && !noautofill
        && !NULL (bf_cur->auto_fill_hook)
        && current_column () > XFASTINT (bf_cur->fill_column))
diff -arcN emacs-18.55/src/config.h-dist nemacs-3.3.2/src/config.h-dist
*** emacs-18.55/src/config.h-dist	Thu Apr 21 17:18:33 1988
--- nemacs-3.3.2/src/config.h-dist	Wed Jun  6 03:18:41 1990
***************
*** 1,3 ****
--- 1,5 ----
+ /* 90.2.27  modified for Nemacs Ver.3.3.1 by K.Handa */
+ 
  /* GNU Emacs site configuration template file.
     Copyright (C) 1988 Free Software Foundation, Inc.
  
***************
*** 19,25 ****
  and this notice must be preserved on all copies.  */
  
  
- 
  /* Include here a s- file that describes the system type you are using.
     See the file ../etc/MACHINES for a list of systems and
     the names of the s- files to use for them.
--- 21,26 ----
***************
*** 106,111 ****
--- 107,121 ----
  #define PURESIZE 118000
  #endif
  #endif
+ 
+ /* 90.2.27  patch by K.Handa */
+ /* define NEMACS if you want to make Nemacs */
+ #define NEMACS
+ #ifdef NEMACS
+ #include "nconfig.h"
+ #include "puresize.h"
+ #endif
+ /* end of patch */
  
  /* Define HIGHPRI as a negative number
     if you want Emacs to run at a higher than normal priority.
diff -arcN emacs-18.55/src/dispextern.h nemacs-3.3.2/src/dispextern.h
*** emacs-18.55/src/dispextern.h	Thu Dec 11 13:39:55 1986
--- nemacs-3.3.2/src/dispextern.h	Wed Jun  6 03:18:54 1990
***************
*** 1,3 ****
--- 1,7 ----
+ /* 89.2.9   modified for Nemacs Ver.3.0 by K.Handa */
+ /* 89.11.24 modified for attribute of characters by K.Handa */
+ /* Currently supported attributes are underline and inverse. */
+ 
  /* Interface definitions for display code.
     Copyright (C) 1985 Free Software Foundation, Inc.
  
***************
*** 61,66 ****
--- 65,74 ----
      struct display_line *next;	/* Chain for free lines. */
      short   length;		/* the number of valid characters in body */
      char    highlighted;	/* 1 means write this line in standout mode */
+     char    kanji_flag;		/* 1 means the kanji_flag of the
+ 				   buffer of this line is T */
+ /* patch for attribute by K.Handa  89.11.21 */
+     char    attribute[MScreenWidth + 4]; /* attribute of each character */
      char    physical;		/* Mark bit for gc'ing, in update_screen */
      char    body[MScreenWidth + 4];	/* the actual text of the line */
  };
***************
*** 69,71 ****
--- 77,85 ----
   to start output in it at `hpos' (origin 0, may be negative) */
  
  struct display_line *get_display_line (), *new_display_line ();
+ 
+ /* patch for attribute by K.Handa  89.11.21 */
+ #define ATTR_UNDERLINE	1
+ #define ATTR_INVERSE	2
+ extern char *attribute_p;	/* oops! */
+ /* end of patch */
